#!c:\cygwin\bin\perl.exe -w
use strict;

use LWP::Simple qw(get);
use Date::Simple ('date', 'today');
use Date::Calc qw(Day_of_Week);
use HTML::Entities;

sub Calendars ($cal_1_name, $cal_1_url, $cal_2_name, $cal_2_url, $cal_3_name, $cal_3_url, $cal_4_name, $cal_4_url, $cal_5_name, $cal_5_url, $cal_6_name, $cal_6_url){

my @output;

my %calendars = @_;

my $params = "?futureevents=true&orderby=starttime&sortorder=ascending&singleevents=true";

my %months = ( "Jan", "01", "Feb", "02", "Mar", "03", "Apr", "04", "May", "05", "Jun", "06"
       , "Jul", "07", "Aug", "08", "Sep", "09", "Oct", "10", "Nov", "11", "Dec", "12");
my %days = ("0", "Sun", "1", "Mon", "2", "Tue", "3", "Wed", "4", "Thu", "5", "Fri", "6", "Sat");
   
my $calendar_name;
my $calendar_url;
my @lines;

my $setunits = sub {
                                                                                         $main::unit = " days    ";
 if      ($main::duration > 30) {$main::unit = " months  "; $main::duration = int(($main::duration / 30) + .5);}
 elsif ($main::duration > 10) {$main::unit = " weeks   "; $main::duration = int(($main::duration / 7) + .5);}
 elsif ($main::duration == 1) {$main::unit = "Tomorrow "; $main::duration = "";}
 elsif ($main::duration == 0) {$main::unit = "Today    "; $main::duration = "";}  
 elsif ($main::duration <  0) {$main::unit = "Passed" ; $main::duration = "";}  
};

while (($calendar_name, $calendar_url) = each(%calendars)){

 next if '' eq $calendar_name;

 my $calendar_data = get "$calendar_url$params";
 @lines = split(/\n/, $calendar_data);

 foreach (@lines) {
  s/&amp;/&/g;
 
  if (/<title type='html'>([\d\D]*)<\/title><summary type='html'>When: (\S+) (\S+) (\S+) (\S+)&lt;br&gt;/
  || /<title type='html'>([\d\D]*)<\/title><summary type='html'>When: (\S+) (\S+) (\S+) (\S+) ([0-9]+:[0-9]+ to [0-9]+:[0-9]+)&nbsp;/)
  {
   my $event = decode_entities($1);
   my $day = "$3";
   if ($3 < 10 ) {
    $day = "0$3";
   }
 
   $main::duration = date("$5-$months{$4}-$day") - today();
   &$setunits();
   if ($6) {$event = $event . "   (" . $6 . ")"}
   push @output, "$5 $months{$4} $day $2\t$main::duration$main::unit\t$calendar_name\t$event\n";
  }
 }

}

@output = sort (@output);
return join "", reverse @output[0..19];
}
print &Calendars();